<?php
/*
 * Пример работы с веб-хуками API
 * отправка уведомлений в slack
 */


// Отправка сообщения в slack - https://api.slack.com/methods/chat.postMessage
function sendSlackMessage($channel, $from, $msg){
	// Токен можно получить тут https://api.slack.com/web
	$token = 'xuxu-8043992880-8270042386-********-63a0c7d0d1';
	
	$curl = curl_init('https://slack.com/api/chat.postMessage');
	curl_setopt_array($curl, array( CURLOPT_RETURNTRANSFER => true, CURLOPT_POST => true,
		CURLOPT_POSTFIELDS => http_build_query(array( 'mrkdwn' => true,
			'token' => $token, 
			'channel' => $channel, 'username' => $from, 'text' => $msg 
		)),
	));
	return json_decode( curl_exec($curl), 1);
}


/*
 * Обработка присланных данных
 */
if (in_array($_REQUEST['event'], array('lead','pay'))) { $br = '
';
	// Формируем сообщение для отправки 
	// на основе полученной информации о заявке
	$lead = $_REQUEST['data'];

	$pay_statuses = array(
		0 => 'Ожидает оплаты',
		1 => 'В процессе оплаты',
		2 => 'Оплачен',
		3 => 'Ошибка оплаты',
	);

	/* Заголовок/от кого */	
	$from = 'Новая заявка №'.$lead['num'];
	// для оплаты другой заголовок
	if ($_REQUEST['event']=='pay') { 
		$from = 'Оплата заявки №'.$lead['num'];

		if($lead['pay']['status']['code']!=2){
			$from = 'Проблемы с оплатой счёта заявки №'.$lead['num'];;
		}

		if($lead['pay']['test']==1){
			$from = 'Тестовый платёж по заявке №'.$lead['num'];;
		}
	}
	


	/* Сообщение */
	$msg = '';
	// информация об оплате
	if ($_REQUEST['event']=='pay') { 
		$msg .= ':moneybag::moneybag::moneybag:'.$br;
		$msg .= '> *Сумма*: '.$lead['pay']['summ'].' руб'.$br;
		$msg .= '> *Статус*: '.$pay_statuses[ $lead['pay']['status']['code'] ].$br;
		$msg .= '> *Способ оплаты*: '.$lead['pay']['method'].$br;
		$msg .= '> *Комментарий*: '.$lead['pay']['desc'].$br;
		$msg .= '> Время создания: '.date('d.m.Y H:i', $lead['pay']['time_create']).$br;
		$msg .= '> Время оплаты: '.date('d.m.Y H:i', $lead['pay']['time_done']).$br;
	}


	// Информация о заявке
	$msg .= ':raising_hand::skin-tone-2: Заявка со страницы <'.$lead['page']['url'].'|'.$lead['page']['name'].' ('.$lead['page']['url'].')>'.$br;	
	// Поля заявки
	foreach ($lead['form_data'] as $k => $item) {
		$msg .= '          *'.$item['name'].'*: '.$item['value'].$br;
	}
	// Ссылка на оплату счёта
	if($_REQUEST['event']=='lead' && count($lead['pay'])>0){
		$msg .= ':moneybag: _Создан <'.$lead['pay']['pay_link'].'|счёт на оплату>_    ';
	}
	
	// Ссылка на просмотр заявки в админпанели
	$msg .= ':pencil:  <http://'.$_REQUEST['site']['domain'].'/admin/lead/view/?id='.$lead['id'].'|Перейти к заявке>';


	// $msg = '```'.print_r($_REQUEST, true).'```'; // отладка
	
	// Отправляем уведомление
	sendSlackMessage('#general', $from, $msg);
}

